unit ListOMyClass;

  (*****************************************************************************)
  (*                                                                           *)
  (* TListOMyClass: Template unit for type specific versions                   *)
  (* Version:       990904.1623                                                *)
  (*                                                                           *)
  (* Use this template file as a simple (low effort) way to create a type      *)
  (* specific version of either TListO or TListOOUN.                           *)
  (*                                                                           *)
  (* Directions:                                                               *)
  (*   Use Replace to alter content to determine which of TListO or TListOOUN  *)
  (*   is desired from which to derive.                                        *)
  (*   1. Goto the top of the file and replace 'MyClass' with whatever your    *)
  (*      class's name is (no 'T' prefix).                                     *)
  (*   2. If TListOOUN is desired then                                         *)
  (*          Goto the top of the file and Replace 'ListO' with 'ListOOUN'.    *)
  (*   3. Goto the top of the file and copy (Ctrl-C) the unit name.            *)
  (*   4. From Delphi's main menu, select 'File/Save As...' and select the     *)
  (*      directory into which it is to be saved.                              *)
  (*   5. Paste (Ctrl-V) the name copied in step 3, adding '.pas' behind it.   *)
  (*   6. Press 'Save'.  And, the file is now saved.                           *)
  (*   7. The unit is now ready to be used.                                    *)
  (*                                                                           *)
  (* Note: It is important to notice in steps 1 and 2, the type names do *not* *)
  (*       use the 'T' prefix. This is important as it is required to cause    *)
  (*       unit name (above) and the uses clause (below) to be involved in the *)
  (*       replace operations.                                                 *)
  (*                                                                           *)
  (*****************************************************************************)

  interface

    uses
      ListO, MyClass;

    type
      TListOMyClass = class(TListO)
        protected
          bInternal: Boolean; //Used to enforce type.
                              //When set True, ensures ONLY *T methods may be
                              //used to add/change content, not less strictly
                              //typed methods.
          procedure SetItems(iWhat: Integer; oWhat: TObject); override;
              //Do not allow.
          function GetItemsT(iWhat: Integer): TMyClass; virtual;
          procedure SetItemsT(iWhat: Integer; mcWhat: TMyClass); virtual;
        public
          function Add(oWhat: TObject): Integer; override;
          procedure Insert(iWhat: Integer; oWhat: TObject); override;

          function AddT(mcWhat: TMyClass): Integer; virtual;
          function FirstT: TMyClass; virtual;
          procedure InsertT(iWhat: Integer; mcWhat: TMyClass); virtual;
          function LastT: TMyClass; virtual;

          property ItemsT[iWhat: Integer]: TMyClass read GetItemsT write SetItemsT;
        end;

  implementation

    procedure TListOMyClass.SetItems(iWhat: Integer; oWhat: TObject);
      begin
      if not bInternal then
        Error('TListOMyClass.SetItems: Not allowed, please use ItemsT', 0);
      inherited SetItems(iWhat, oWhat);
      end;

    function TListOMyClass.GetItemsT(iWhat: Integer): TMyClass;
      begin
      Result := (Items[iWhat] as TMyClass);
      end;

    procedure TListOMyClass.SetItemsT(iWhat: Integer; mcWhat: TMyClass);
      begin
      bInternal := True;
      try
        Items[iWhat] := mcWhat;
      finally
        bInternal := False;
      end; //try
      end;
//public
    function TListOMyClass.Add(oWhat: TObject): Integer;
      begin
      if not bInternal then
        Error('TListOMyClass.Add: Not allowed, please use AddT', 0);
      Result := inherited Add(oWhat);
      end;

    procedure TListOMyClass.Insert(iWhat: Integer; oWhat: TObject);
      begin
      if not bInternal then
        Error('TListOMyClass.Insert: Not allowed, please use InsertT', 0);
      inherited Insert(iWhat, oWhat);
      end;

    function TListOMyClass.AddT(mcWhat: TMyClass): Integer;
      begin
      bInternal := True;
      try
        Result := Add(mcWhat);
      finally
        bInternal := False;
      end; //try
      end;

    function TListOMyClass.FirstT: TMyClass;
      begin
      Result := TMyClass(First);
      end;

    procedure TListOMyClass.InsertT(iWhat: Integer; mcWhat: TMyClass);
      begin
      bInternal := True;
      try
        Insert(iWhat, mcWhat);
      finally
        bInternal := False;
      end; //try
      end;

    function TListOMyClass.LastT: TMyClass;
      begin
      Result := TMyClass(Last);
      end;

  end.
